﻿Public Class frmMain

    Dim card As New K8055()
    Dim checkboxes(8) As CheckBox
    Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vkey As Long) As Integer



    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' This part of the code puts the reference to all the objects into an Array (of checkboxes).
        ' It is a substute for the old ControlArray() principe in previous versions of Visual Basic.
        checkboxes = New CheckBox() {OUT1, OUT2, OUT3, OUT4, OUT5, OUT6, OUT7, OUT8}
        For i As Integer = 0 To UBound(checkboxes)
            AddHandler checkboxes(i).CheckedChanged, AddressOf Checkbox_CheckedChanged
        Next

        ' Create a connection to the K8000
        card.connect(SK5:=True, SK6:=True)

        ' Determine if the connection was made correctly.
        If card.isConnected() Then
            ' Connection Okay!
            statusbar.Text = "K8055 detected"

            ' Setup the properties of the timer
            keyCheckTimer.Enabled = True
            keyCheckTimer.Interval = 100


        Else
            ' Connection Failed!
            statusbar.Text = "no K8055 detected!"

            ' The timer isn't activated and the checkboxes are Grayed out
            For i As Integer = 0 To UBound(checkboxes)
                checkboxes(i).Enabled = False
            Next
        End If
    End Sub




    ' Update the K8055 for the selected checkbox.
    Private Sub Checkbox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs)
        For i As Integer = 0 To UBound(checkboxes)
            If checkboxes(i).Equals(sender) Then
                If sender.Checked() Then
                    card.setDigitalOutput(i + 1)
                Else
                    card.clearDigitalOutput(i + 1)
                End If
            End If
        Next i
    End Sub





    ' Read the state of all pressed keys every 100 milliseconds. Update the K8055 is necessary.
    Private Sub keyCheckTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles keyCheckTimer.Tick
        ' scheduledForToggling() is an array that remembers the key states during the previous
        ' call to the keyCheckTimer_Tick(). Without it, your outputs would keep inverting as long
        ' as you pressed one of the F-keys.
        Static scheduledForToggling(8) As Boolean

        For i As Integer = 0 To 7
            ' Read the CTRL key + Fx key from the keyboard
            Dim keyState As Boolean = GetAsyncKeyState(Keys.F1 + i)
            Dim controlKey As Boolean = GetAsyncKeyState(Keys.ControlKey)

            If keyState And controlKey Then
                ' Both the Fx and CTRL key are pressed ...
                If scheduledForToggling(i) Then
                    checkboxes(i).Checked = Not checkboxes(i).Checked
                    scheduledForToggling(i) = False
                End If
            Else
                scheduledForToggling(i) = True
            End If
        Next
    End Sub
End Class
